jQuery(function ($) {

    var pb_domain = 'http://playboard.me';
    loadChannels($);

    function loadChannels($) {

        var count = 0;
        $('.pb-channel').each(function () {
            var channel = $(this);
            if (!channel.attr('id')) {
                try {

                    channel.attr('id', 'pb_channel_' + count++);

                    var parsedUri = parseUri(channel.find('a[href]').attr('href').toString());
                    var path = parsedUri['path'];
                    var channel_id = path.substr(path.lastIndexOf('/') + 1);

                    var jsonp_url = pb_domain + "/widgets/pb_channel_widget.json?channel_id=" + channel_id + '&width=' + channel.attr('data-width') + '&referrer=' + window.location;

                    $.ajax({
                        url:jsonp_url,
                        dataType:"jsonp",
                        success:function (data) {

                            channel.html(data);
                            channel.addClass('cleanslate');

                            channel.find('.left_arrow').click(function () {
                                showApp(channel, $(this));
                            });

                            channel.find('.right_arrow').click(function () {
                                showApp(channel, $(this));
                            });
                        },
                        error:function (xhr, ajaxOptions, thrownError) {
                            console.log(xhr.responseText);
                        }
                    });
                } catch (e) {
                    //do nothing
                    console.log(e);
                }

            }
        });
    }

    function showApp(channel, arrow) {

        //show div
        var show_id = arrow.attr('data-show');
        var preload_id = arrow.attr('data-preload');
        var hide_id = arrow.attr('data-hide');

        var div_to_show = channel.find('.' + show_id);
        var div_to_preload = channel.find('.' + preload_id);
        var div_to_hide = channel.find("." + hide_id);
        var img_to_show = div_to_show.find('img:first-child');

        //if loaded show
        if (img_to_show.attr('data-loaded')) {
            div_to_hide.toggleClass('hidden');
            div_to_show.toggleClass('hidden');

        } else {
            //show on load
            img_to_show.on('load', function () {
                div_to_hide.toggleClass('hidden');
                div_to_show.toggleClass('hidden');
            });
        }

        var img_to_preload = div_to_preload.find('img:first-child');
        div_to_preload.find('img:first-child').attr('src', div_to_preload.attr('data-src')).load(function () {
            img_to_preload.attr('data-loaded', true);
        });

    }

    /* parseUri JS v0.1, by Steven Levithan (http://badassery.blogspot.com) */
    function parseUri(sourceUri) {
        var uriPartNames = ["source", "protocol", "authority", "domain", "port", "path", "directoryPath", "fileName", "query", "anchor"];
        var uriParts = new RegExp("^(?:([^:/?#.]+):)?(?://)?(([^:/?#]*)(?::(\\d*))?)?((/(?:[^?#](?![^?#/]*\\.[^?#/.]+(?:[\\?#]|$)))*/?)?([^?#/]*))?(?:\\?([^#]*))?(?:#(.*))?").exec(sourceUri);
        var uri = {};

        for (var i = 0; i < 10; i++) {
            uri[uriPartNames[i]] = (uriParts[i] ? uriParts[i] : "");
        }

        if (uri.directoryPath.length > 0) {
            uri.directoryPath = uri.directoryPath.replace(/\/?$/, "/");
        }

        return uri;
    }

    function getQueryVariable(variable, query) {
        var vars = query.split("&");
        for (var i = 0; i < vars.length; i++) {
            var pair = vars[i].split("=");
            if (pair[0] == variable) {
                return unescape(pair[1]);
            }
        }

    }
});